% Los programas son para fines educativo y se ofrecen para uso publico en educacin
% Maestria en Ciencias de la Computacin.
% Dr. Carlos BAn Romero
% Septiembre de 2018
% basado en 
% wikibooks: Algorithm Implementation/Sorting/Heapsort
% https://en.wikibooks.org/wiki/Algorithm_Implementation/Sorting/Heapsort
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function heapS(n,dopt)
global A;
nh = n;
if (n <= 1) % check if heap is empty
    return;
end
t=0; %/* the temporary value */
parent = fix((nh+1)/2)+1;
index = 0 ;
child = 0; % /* heap indexes */
% /* loop until Aay is sorted */
while (1) % {
    if (parent > 1) % {
        % /* first stage - Sorting the heap */
        parent = parent - 1;
        t = A(parent);  % /* save old value to t */
        % }
    else % {
        % /* second stage - Extracting elements in-place */
        if (nh == 1) % {
            return %; /* When the heap is empty, we are done */
        end
        t = A(nh);  % /* save lost heap entry to temporary */
        A(nh) = A(1); %  /* save root entry beyond heap */
        if (dopt == 1)
            bar(A(1:n));
            axis tight;
            hold on;
            ma=zeros(n,1);
            ma(parent) = max(A)*1.1;
            bar(ma,'r');
            ma=zeros(n,1);
            ma(1)=A(1);
            ma(nh)=A(nh);
            bar(ma,'g');
            line=sprintf('t=%6.4g',t);
            disp(line);
            disp(A(1:n)');
            line=sprintf('extract parent=%d index=%d child=%d 1->nh=%d', ...
                parent,index,child,nh);
            title(line);
            disp(line);
            drawnow;
            hold off;
            pause ;
        end
        nh = nh - 1;  % /* make the heap smaller */
    end
    % /* insert operation - pushing t down the heap to replace the parent */
    index = parent; % /* start at the parent index */
    child = index * 2; % /* get its left child index */
    while (child <= nh) % {
        % /* choose the largest child */
        if (child + 1 <= nh)  &&  (A(child + 1) > A(child)) % {
            child = child + 1; %/* right child exists and is bigger */
        end % }
        % /* is the largest child larger than the entry? */
        if (A(child) > t) % {
            A(index) = A(child); % /* overwrite entry with child */
            if (dopt == 1)
                bar(A(1:n));
                axis tight;
                hold on;
                ma=zeros(n,1);
                ma(parent) = max(A)*1.1;
                bar(ma,'r');
                ma=zeros(n,1);
                ma(index)=A(index);
                ma(child)=A(child);
                bar(ma,'g');
                line=sprintf('t=%6.4g',t);
                disp(line);
                disp(A(1:n)');
                line=sprintf('inserta parent=%d index=%d<-child=%d nh=%d', ...
                    parent,index,child,nh);
                title(line);
                disp(line);
                drawnow;
                hold off;
                pause;
            end
            index = child; % /* move index to the child */
            child = index * 2; % /* get the left child and go around again */
            %}
        else % {
            break; % /* t's place is found */
        end % }
    end % }
    % /* store the temporary value at its new location */
    A(index) = t;
    if (dopt == 1)
        bar(A(1:n));
        axis tight;
        hold on;
        ma=zeros(n,1);
        ma(parent)=max(A)*1.1;
        bar(ma,'r');
        ma=zeros(n,1);
        ma(index)=A(index);
        bar(ma,'g');
        line=sprintf('t=%6.4g',t);
        disp(line)
        disp(A(1:n)');
        line=sprintf('heap parent=%d t->index=%d child=%d nh=%d', ...
            parent,index,child,nh);
        title(line);
        disp(line);
        drawnow;
        hold off;
        pause;
    end
end